package  
{
	import flash.geom.Vector3D;
	import org.flixel.*;
	
	/**
	 * ...
	 * @author Nathan McCoy
	 */
	public class Attack extends FlxSprite 
	{
		[Embed(source = "../lib/uglyattack2.png")]
		public static const AttackGraphic:Class;
		[Embed(source = "../lib/nodamage.mp3")]
		public static const InvulnSound:Class;
		
		
		
		public var parent:Critter;	
		private var disp:Vector3D;
		private var skewfactor:Number = (Math.random() - Math.random());
		private var hits:Array;
		public var radius:Number = 6;
		public function Attack(p:Critter) 
		{
			super();
			parent = p;			
			disp = new Vector3D();
			makeGraphic(12, 12);
			width = 0;
			height = 0;
			centerOffsets();
			exists = false;
			loadGraphic(AttackGraphic, true);
			//addAnimation("flicker", new Array(0, 1), 30, true);
			//play("flicker", true);
			hits = new Array();
		}
		public override function update():void
		{
			if (parent.swing_timer <= 0) 
			{
				exists = false;
				skewfactor = (Math.random() - Math.random());
				hits.length = 0;
			}
			else
			{
				var span:Number = 1.0 - 1.0 * parent.swing_timer / parent.attack_speed;
				var extent:Number = Math.sin(span * Math.PI);
				disp.x = parent.facing_vector.x;
				disp.y = parent.facing_vector.y;
				disp.scaleBy(extent * parent.attack_reach);
				disp.x += parent.facing_vector.y * skewfactor * (span - 0.5) * parent.radius*3;
				disp.y += -parent.facing_vector.x * skewfactor * (span - 0.5) * parent.radius*3;
				x = parent.x + disp.x;
				y = parent.y + disp.y;
				
				for (var i:int = 0; i < parent.ps.critters.length; i++)
				{
					var c:Critter = parent.ps.critters.members[i] as Critter;
					if (c.exists)
					{
						var r:Number = radius + c.radius;
						r = r * r;
						if (c != parent && (c.x - x) * (c.x - x) + (c.y - y) * (c.y - y) < r)
						{
							if (hits.indexOf(c) == -1)
							{
								hits.push(c);
								if (!c.invulnerable) parent.hit(c);
								else
								{
									FlxG.play(InvulnSound);
									c.ps.damageParticle(c.x, c.y, 0);
								}
							}
						}
					}
				}
			}
			color = parent.color;
			super.update();
		}
		
	}

}