package  
{
	import org.flixel.*;
	
	
	/**
	 * ...
	 * @author Nathan McCoy
	 */
	public class DamageParticle extends FlxText 
	{
		private var lifetime:int;
		private var playerDamage:Boolean;
		private var driveAmount:Number;
		
		public function init(X:Number, Y:Number, damage:Number, player:Boolean = false, drive:Number = 0):void
		{
			x = X;
			y = Y;
			text = int(damage).toString();
			setFormat("FivePixel", 8, 0xFFFFFF, "center", 0x000001);
			lifetime = 30;
			visible = false;
			playerDamage = player;
			x -= 15;
			y -= 8;
			velocity.x = (Math.random() - Math.random()) * 10;
			velocity.y = -80;
			acceleration.y = 320;
			driveAmount = drive;
			exists = true;
		}
		
		public function DamageParticle(X:Number=0, Y:Number=0, damage:Number=0, player:Boolean = false, drive:Number = 0) 
		{
			super(X, Y, 30, int(damage).toString());
			init(X, Y, damage, player, drive);
		}
		override public function update():void 
		{
			lifetime--;
			visible = true;
			var dc:int = (FlxG.state as PlayState).drivecolor(driveAmount);
			if(playerDamage) setFormat("FivePixel", 8, dc, "center", 0x000001);
			super.update();
			if (lifetime <= 0) exists = false;
		}
		
	}

}