package  
{
	import org.flixel.FlxPoint;
	/**
	 * ...
	 * @author Nathan McCoy
	 */
	public class Foe extends Critter 
	{
		[Embed(source = "../lib/dot.png")]
		public static const DotGraphic:Class;
		
		public static var _fitness:Number = 0;
		
		override public function get fitness():Number
		{
			return _fitness;
		}
		
		public function Foe(X:Number=0, Y:Number=0, SimpleGraphic:Class=null) 
		{
			super(X, Y, SimpleGraphic);
			loadGraphic(DotGraphic);
			radius = 8;
			width = 0; height = 0; centerOffsets();
			BASE_WALK = 70;
			BASE_POWER = 10;
			BASE_COMBO = 20;
			_fitness = 0;
			recalcStats();
		}
		public override function update():void
		{
			if (ps.player.exists)
			{
				//if (!ps.player.overdrive)
				//{
					movement_intent.x = ps.player.x - x;
					movement_intent.y = ps.player.y - y;
					key_attack_edge = false;
					if (Math.sqrt((ps.player.x - x) * (ps.player.x - x) + (ps.player.y - y) * (ps.player.y - y)) < attack_reach + my_attack.radius) 
					{
						movement_intent.x = ps.player.x - x;
						movement_intent.y = ps.player.y - y;
						key_attack_edge = true;
					}
				//}
				//else
				//{
				//	movement_intent.x = -ps.player.x + x;
				//	movement_intent.y = -ps.player.y + y;
				//}
				key_dash_edge = false;
				for (var i:int = 0; i < ps.critters.length; i++)
				{
					var c:Critter = ps.critters.members[i] as Critter;
					
					if (c.exists && c != this)
					{
						if (Math.sqrt((c.x - x) * (c.x - x) + (c.y - y) * (c.y - y)) < radius * 2)
						{
							movement_intent.x = x - c.x;
							movement_intent.y = y-c.y;
							key_dash_edge = true;
						}
						
					}
				}
			}
			else 
			{
				movement_intent.x = movement_intent.y = 0;
				key_attack_edge = false;
				key_dash_edge = false;
			}
			
			
			super.update();
		}
		override public function die():void 
		{
			if (ps.player.overdrive) 
			{
				ps.mutationqueue.push(new Mutation(Math.floor(Math.random() * 3 + 1), Math.random() * 0.6 - 0.2));
				ps.overdrive_combo++;
			}
			else ps.score += 100;
			super.die();
		}
		override public function hit(target:Critter):void 
		{
			super.hit(target);
			if (target == ps.player) _fitness += attack_strength;
		}
	}

}