package  
{
	import org.flixel.FlxGroup;
	import org.flixel.FlxSprite;
	
	/**
	 * ...
	 * @author Nathan McCoy
	 */
	public class Lifedot extends FlxSprite 
	{
		[Embed(source = "../lib/lifedot.png")]
		public static const LifeGraphic:Class;
		public static const TENSION:Number = 2;
		public static const DAMPING:Number = 0.1;
		
		public var parent:Critter;
		public function Lifedot(c:Critter) 
		{
			super();
			loadGraphic(LifeGraphic, true, false);
			parent = c;
			width = 0;
			height = 0;
			centerOffsets();
			c.my_lifedot = this;
		}
		override public function update():void 
		{
			velocity.x += TENSION * (parent.x - 8 - x);
			velocity.y += TENSION * (parent.y - 8 - y);
			
			velocity.x *= (1 - DAMPING);
			velocity.y *= (1 - DAMPING);
			
			var hostlife:Number = parent.hp / parent.max_hp;
			frame = 9 - int(hostlife * 9);
			alpha = parent.alpha;
			
			if (!parent.exists || parent.my_lifedot != this)
			{
				var i:int;
				var critters:FlxGroup = parent.ps.critters;
				for (i = 0; i < critters.length; i++)
				{
					if ((critters.members[i] as Critter).my_lifedot == null)
					{
						parent = critters.members[i] as Critter;
						parent.my_lifedot = this;
					}
				}
			}
			
			super.update();
		}
		
	}

}