package
{

	import org.flixel.*;
	import Fonts;
	import org.flixel.plugin.photonstorm.FlxColor;
	public class MenuState extends FlxState
	{
		
		private var playButton:FlxButton;
		private var devButton:FlxButton;
		private var Title:FlxText;
		
		[Embed(source = "../lib/dragoncore.png")]
		public const Dragoncore:Class;
		[Embed(source = "../lib/overdrive.png")]
		public const Overdrive:Class;
		public var overdrive_sprite:FlxSprite;
		public var framespinner:int;
		override public function create():void
		{
			framespinner = 0;
			FlxG.bgColor = 0xff000000;
			new Fonts();
			
			add(new FlxSprite(0, 0, Dragoncore));
			add(overdrive_sprite = new FlxSprite(0, 0, Overdrive));
			
			
			Title = new FlxText(FlxG.width / 4, FlxG.height /2, 200, "X = dash\nC = attack\nArrows = move\n\nPounce: hold C, dash")
			//Title.alignment("center");
			Title.setFormat("PressStartK");
			add(Title);
			
			devButton = new FlxButton(FlxG.width/2-40,FlxG.height / 3 + 60, "Mutation", onSite);
			devButton.soundOver = null;  //replace with mouseOver sound
			devButton.color = 0xffae1639;
			devButton.label.color = 0xffFFFFFF;
			//add(devButton);
			
			playButton = new FlxButton(FlxG.width/2-40,FlxG.height / 3 + 100, "Let's Do This", onPlay);
			playButton.soundOver = devButton.soundOver;
			playButton.color = devButton.color;
			playButton.label.color = devButton.label.color;
			add(playButton);
			
			
			FlxG.mouse.show();
			
		}
		
		override public function update():void
		{
			super.update();	
			framespinner++;
			overdrive_sprite.color = FlxColor.HSVtoRGB((framespinner * 5) % 360, 0.3, 1);
		}
		
		protected function onSite():void
		{
			Title.text=new Mutation(4, 0.25).description;
			//FlxU.openURL("http://example.com/");  //replace with your site's URL 
		}
		
		protected function onPlay():void
		{
			playButton.exists = false;
			FlxG.switchState(new PlayState());
		}
		
		
	}
}

